//    Copyright (C) 2004 Michael Mahr

//    This file is part of "lesschess".
//
//    "lesschess" is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    "lesschess" is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with "lesschess"; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef __ascmodel__
#define __ascmodel__

#include "defs.h"
#include <iostream>
#include <string>
#include <fstream>
#include <map>

//this Class loads and stores the data of a asc-file in a rather unperformant, but convenient way.

struct AscVector
{
  float x;
  float y;
  float z;
};

struct AscFace
{
  unsigned int a;
  unsigned int b;
  unsigned int c;
};

//ascreaders own Exception
class AscException: public Exception
{
public:
  AscException() : Exception(){};
  AscException(std::string _message) : Exception(_message){};
};


class AscModel
{
public:
  //map allows for faster access
  std::map<unsigned int, AscVector> verticles;
  std::map<unsigned int, AscFace> faces;

public:
  AscModel(std::string filename);
  ~AscModel();
};


#endif
