//    Copyright (C) 2004 Michael Mahr

//    This file is part of "lesschess".
//
//    "lesschess" is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    "lesschess" is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with "lesschess"; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef __game__
#define __game__

#include "smoothvalue.h"
#include "sps2chessboard.h"
#include "sps2chesspiece.h"
#include "defs.h"

#include "ds2pad/ds2pad.h"

#include <iostream>
#include <string>
#include <math.h>

class Game
{
private:
  SPS2Chessboard<SPS2Chesspiece> board;
  
  SmoothValue xrotation;
  SmoothValue yrotation;
  SmoothValue distance;
  
  void relmove(int x, int y); //move pieces relative to cursor and camera position

  void ensure360 (); //makes sure that xrotation and yrotation (and their current-counterparts) are between 0 and 360
  
public:
  Game();
  virtual ~Game();
 
  bool draw(unsigned int msecs, unsigned char * buttons);
};


#endif
