//    Copyright (C) 2004 Michael Mahr

//    This file is part of "lesschess".
//
//    "lesschess" is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    "lesschess" is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with "lesschess"; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#include "padmanager.h"

Padmanager::Padmanager ()
{

/*
  pad = new DS2Pad("/dev/ps2pad00");

  pad->analogmode(true);
  pad->lockmode(true);
  
  pad->update();
 
  std::cout << "stat  " << pad->checkstat() << std::endl;
  std::cout << "rstat " << pad->checkrstat() << std::endl;
  
  sleep(1);

  std::cout << "stat  " << pad->checkstat() << std::endl;
  std::cout << "rstat " << pad->checkrstat() << std::endl;
  
  delete pad;

*/

  pad = new DS2Pad("/dev/ps2pad00");

  pad->analogmode(true);
  pad->lockmode(true);  
}


unsigned char * Padmanager::getbuttons()
{
  pad->update();
  
  for (int j = 0; j < 16; j++)
  {
    if ( oldpressed[j] && pad->pressed[j])
      buttons[j] = 4;
    else if ( oldpressed[j] && !pad->pressed[j])
      buttons[j] = 2;
    else if ( !oldpressed[j] && pad->pressed[j])
      buttons[j] = 5;
    else if ( !oldpressed[j] && !pad->pressed[j])
      buttons[j] = 0;
  }
  
  buttons[16] = pad->rightstickx;
  buttons[17] = pad->rightsticky;
  buttons[18] = pad->leftstickx;
  buttons[19] = pad->leftsticky;

  //old states
  for (int i = 0; i < 16; i++)
  {
    oldpressed[i] = pad->pressed[i];
  }
    
  return buttons;
}

Padmanager::~Padmanager()
{
  delete pad;
}
