//    Copyright (C) 2004 Michael Mahr

//    This file is part of "lesschess".
//
//    "lesschess" is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    "lesschess" is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with "lesschess"; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#include "smoothvalue.h"

SmoothValue::SmoothValue()
{
  target = 0;
  value = 0;
}

SmoothValue::SmoothValue(float initvalue)
{
  init(initvalue);
}

void SmoothValue::init(float initvalue)
{
  target = initvalue;
  value = initvalue;  
}

void SmoothValue::calculate(float interval)
{
  if(!(target == value))
  {
    bool positive = true;
    float fx = value - target;
  
    if(fx < 0)
    {
      fx = -(fx);
      positive = false;
    }
  
    float x = sqrt(fx);
    x -= interval;
    
    if (x < 0)
    {
      value = target;
    }
    else
    {
      fx = pow(x,2);
      
      if (!positive)
        fx = -(fx);
	
      value = target + fx;
    }
    
  }
  
}
