//    Copyright (C) 2004 Michael Mahr

//    This file is part of "lesschess".
//
//    "lesschess" is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    "lesschess" is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with "lesschess"; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#include "sps2chesspiece.h"

SPS2Chesspiece::SPS2Chesspiece (bool _white, int _value, int _x, int _y):Chesspiece(_white,_value,_x,_y)
{
  currentx=_x;
  currenty=_y;

  std::string path = "./pieces/";


  switch (getvalue())
  {
  case 0:
    path += "pawn.asc";
    break;
  case 1:
    path += "knight.asc";
    break;
  case 2:
    path += "rook.asc";
    break;
  case 3:;
    path += "bishop.asc";
    break;
  case 4:
    path += "queen.asc";
    break;
  case 5:
    path += "king.asc";
    break;
  }

  float modelrotation[] = {1,0,0,-90};
  float lightcolor[] = {0.5,0.5,0.5};
  float lightorigin[3];
  float modelscale[3];
  float color[3];
  
  //white pieces are flipped - therefore the lightorigin was changed too
  if (_white)
  {
    color[0] = 0.6; color[1] = 0.6; color[2] = 0.6;
    modelscale [0] = -0.1; modelscale[1] = 0.1; modelscale[2] = -0.1;
    lightorigin[0] = 1; lightorigin[1] = -0.5; lightorigin[2] = -1;
  }
  else
  {
    color[0] = 0; color[1] = 0; color[2] = 0;
    modelscale [0] = 0.1; modelscale[1] = 0.1; modelscale[2] = 0.1;
    lightorigin[0] = -1; lightorigin[1] = 0.5; lightorigin[2] = -1;
  }
  
  glasc = new SPS2AscModel(path, modelscale, modelrotation, color, lightcolor, lightorigin);

}

void SPS2Chesspiece::draw()
{

  currentx=getx()+(currentx-getx())*0.9f;
  currenty=gety()+(currenty-gety())*0.9f;

  /*
  if (getwhite())
      glColor4f(0.8,0.8,0.8,1);
  else
      glColor4f(0,0,0,1);
  */  
  
  
  matrixmanager.modelviewPushTranslate(currentx-3.5, 0, currenty-3.5);
  
  glasc->draw();
 
  matrixmanager.modelviewPop();
}

SPS2Chesspiece::~SPS2Chesspiece()
{
  delete glasc;
}
